﻿#pragma strict

var isDefeated : boolean = false;
var moveSpeed : float;
var player : GameObject;
private var attackDistance : float = 1.9;
private var stopMovingDistance : float = 1.3;
public var huggerOrStriker : String;

//SFXs
var angerSfx : AudioClip;
var huggerDeathSfx : AudioClip;
var strikerDeathSfx : AudioClip;

function Start () {
	if (Random.value > 0.6)
		huggerOrStriker = "Hugger";
	else
		huggerOrStriker = "Striker";
}

function Update () {
	if (GameScript.gameStatus == "Running" && !isDefeated) {
		AnimateEnemy();
	}
}

function LookAtPlayer () {
	var point: Vector3 = player.transform.position;
	point.y = 0.0;
	transform.LookAt(point);
}

function AnimateEnemy () {
	if (player == null)
		player = GameScript.playerObject;
	
	var distanceToPlayer = Vector3.Distance(player.transform.position, transform.position);
	
	if (distanceToPlayer > stopMovingDistance)
		transform.position += (transform.forward * (moveSpeed * Time.deltaTime));
	
	LookAtPlayer();
}

function AggressiveWordHit () {
	if (huggerOrStriker == "Striker") {
		moveSpeed = 0;
		collider.enabled = false;
		audio.PlayOneShot(strikerDeathSfx, 0.7);
		isDefeated = true;
	}
	else if (huggerOrStriker == "Hugger") {
		moveSpeed += 1;
		huggerOrStriker = "Striker";
		GameScript.depression += 30;
	}
}

function DismissiveWordHit () {
	if (huggerOrStriker == "Striker") {
		moveSpeed += 1;
		audio.PlayOneShot(angerSfx, 0.7);
		GameScript.depression += 20;
	}
	else if (huggerOrStriker == "Hugger") {
		moveSpeed = 0;
		collider.enabled = false;
		audio.PlayOneShot(huggerDeathSfx, 0.7);
		isDefeated = true;
	}
}

@script RequireComponent(AudioSource);