﻿#pragma strict

static var playerPosX : float;
static var playerPosZ : float;
static var wordThatWasFired : String;
private var moveSpeed : float = 1.2;
private var maxPosY : float = 4;
private var minPosY : float = -4;
private var maxPosX : float = 5;
private var minPosX : float = -5;
private var sensitivity : float = 10;
private var weaponTimer : float = 1;

var aggressiveWord : GameObject;
var dismissiveWord : GameObject;
var firingPoint : GameObject;

//SFXs
public var aggressiveAttack = new AudioClip[3];
public var dismissiveAttack = new AudioClip[3];

function Start(){
	playerPosX = gameObject.transform.position.x;
	playerPosZ = gameObject.transform.position.z;
}

function Update(){
	if (GameScript.gameStatus == "Running"){
		Movement();
		Weapon();
	}
}

function Movement(){
	gameObject.transform.position.x = playerPosX;
	gameObject.transform.position.z = playerPosZ;
	
	if (Input.GetKey ("w") && !Input.GetKey ("s")){
		playerPosZ += (moveSpeed * 0.05);
	}
	else if (Input.GetKey ("s") && !Input.GetKey ("w")){
		playerPosZ -= (moveSpeed * 0.05);
	}
	
	if (Input.GetKey ("a") && !Input.GetKey ("d")){
		playerPosX -= (moveSpeed * 0.05);
	}
	else if (Input.GetKey ("d") && !Input.GetKey ("a")){
		playerPosX += (moveSpeed * 0.05);
	}
	
	if (playerPosZ > maxPosY)
		playerPosZ = maxPosY;
	if (playerPosZ < minPosY)
		playerPosZ = minPosY;
	if (playerPosX > maxPosX)
		playerPosX = maxPosX;
	if (playerPosX < minPosX)
		playerPosX = minPosX;
}

function Weapon(){
	weaponTimer += Time.deltaTime;
	
	if (weaponTimer > 0.5){
		if(Input.GetMouseButtonDown(0)){
			wordThatWasFired = "Aggressive";
			var aggressiveWord : GameObject = Instantiate(aggressiveWord, firingPoint.transform.position, firingPoint.transform.rotation);
			weaponTimer = 0;
			audio.PlayOneShot(aggressiveAttack[Random.value * 3]);
		}
		
		if(Input.GetMouseButtonDown(1)){
			wordThatWasFired = "Dismissive";
			var dismissiveWord : GameObject = Instantiate(dismissiveWord, firingPoint.transform.position, firingPoint.transform.rotation);
			weaponTimer = 0;
			audio.PlayOneShot(dismissiveAttack[Random.value * 3]);
		}
	}
}

@script RequireComponent(AudioSource);